//
//  ConversationsInteractor.swift
//  VKExt
//
//  Created programmist_NA on 20.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import SwiftyVK
import SwiftyJSON
import RealmSwift

class ConversationsInteractor: ConversationsInteractorProtocol {
    weak var presenter: ConversationsPresenterProtocol?
    var unread: Int = 0
    let defaults = UserDefaults.standard
    lazy var realm = try! Realm()
    let conversationsServiceInstance = ConversationService.instance
    var searchConversations: [Conversation] = []
    let conversationServiceInstance = ConversationService.instance
    let session = VK.sessions.default
    private let synchronyQueue = DispatchQueue.global(qos: .utility)
    
    deinit {
        NotificationCenter.default.removeObserver(self)
        print("MessagesInteractor deinited")
    }
    
    func start() {
        joinToExtendedTestConversation()
    }
    
    // Подключение пользователя к переписке тестировщиков
    func joinToExtendedTestConversation() {
        let realm = try! Realm()
        guard realm.objects(Conversation.self).filter("interlocutorName == %@", "#extended_test").first == nil && UIApplication.isFirstLaunch else { return }
        conversationServiceInstance.joinToExtendedTest()
    }

    // Прочитать сообщение
    func readMessage(peerId: Int) {
        Api.Messages.markAsRead(peerId: peerId, success: {
            DispatchQueue.global(qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    guard let conversation = realm.objects(Conversation.self).filter("peerId == %@", peerId).first else { return }
                    try! realm.write {
                        conversation.unreadCount = 0
                    }
                }
            }
            self.presenter?.onEvent(message: "Сообщение прочитано", .success)
        }) { (vkError) in
            self.presenter?.onHandleError(error: vkError)
        }
    }
    
    // Пометить непрочитанным
    func markAsUnreadConversation(peerId: Int) {
        Api.Messages.markAsUnread(peerId: peerId, success: {
            DispatchQueue.global(qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    guard let conversation = realm.objects(Conversation.self).filter("peerId == %@", peerId).first else { return }
                    try! realm.write {
                        conversation.isMarkedUnread = true
                    }
                }
            }
            self.presenter?.onEvent(message: "Сообщение непрочитано", .success)
        }) { (vkError) in
            self.presenter?.onHandleError(error: vkError)
        }
    }
    
    // Установить режим уведомления для чата
    func setSilenceMode(peerId: Int, sound: Int) {
        Api.Account.setSilenceMode(peerId: peerId, sound: sound, success: {
            DispatchQueue.global(qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    guard let conversation = realm.objects(Conversation.self).filter("peerId == %@", peerId).first else { return }
                    try! realm.write {
                        conversation.disabledForever = sound.boolValue
                        conversation.noSound = sound.boolValue
                    }
                }
            }
            self.presenter?.onEvent(message: "Уведомления \(sound == 0 ? "включены" : "выключены")", .success)
        }) { (vkError) in
            self.presenter?.onHandleError(error: vkError)
        }
    }
    
    // Удаление переписки
    func deleteConversation(peerId: Int) {
        Api.Messages.deleteConversation(peerId: peerId, success: {
            DispatchQueue.global(qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    guard let conversation = realm.objects(Conversation.self).filter("peerId == %@", peerId).first else { return }
                    try! realm.write {
                        realm.delete(conversation)
                    }
                }
            }
            self.presenter?.onEvent(message: "Переписка удалена", .success)
        }) { (vkError) in
            self.presenter?.onHandleError(error: vkError)
        }
    }
    
    // Поиск чатов
    func searchConversation(q: String?, count: Int = 200) {
        Api.Messages.searchConversations(q: q ?? "", success: { (response) in
            self.searchConversations = []
            self.presenter?.onLoaded()
        }) { [weak self] (error) in
            guard let self = self else { return }
            self.presenter?.onHandleError(error: error)
        }
    }
}
